=== Makefile ===
#--------------------------------------------------------------------
# build process
#
#



# ------------------------------------------------------------------------------
# programs
#
# Users should make all changes in make.inc
# It should not be necesary to change anything in here.

include make.inc

# --------------------
# configuration

# should MAGMA be built on CUDA (NVIDIA only) or HIP (AMD or NVIDIA)
# enter 'cuda' or 'hip' respectively
BACKEND     ?= cuda

# set these to their real paths
CUDADIR     ?= /usr/local/cuda
HIPDIR      ?= /opt/rocm/hip

# require either hip or cuda
ifeq (,$(findstring $(BACKEND),"hip cuda"))
    $(error "'BACKEND' should be either 'cuda' or 'hip' (got '$(BACKEND)')")
endif

# --------------------
# programs

# set compilers
CC          ?= gcc
CXX         ?= g++
FORT        ?= gfortran
HIPCC       ?= hipcc
NVCC        ?= nvcc
DEVCC       ?= NONE

# Configuration variables
HAVE_CUDA  =
HAVE_HIP   =
CUDA_ARCH_MIN =

# CMake.src file, which depends on the backend
CMAKESRC     = CMake.src.$(BACKEND)

# set from 'BACKEND'
ifeq ($(BACKEND),cuda)
    DEVCC = $(NVCC)
	HAVE_CUDA = 1

else ifeq ($(BACKEND),hip)
    DEVCC = $(HIPCC)
	HAVE_HIP = 1

    # if we are using HIP, make sure generated sources are up to date
    # Technically, this 'recursive' make which we don't like to do, but also this is a simple solution
    #   that allows that file to handle all code generation
    # Another reason is that I don't want to flood the namespace (for example, that file also
    #   defines an 'all' and 'clean' target as phonies)
    # So, in the future that whole file may be integrated, but for now this seems simplest
	# Detect number of jobs here, so it runs at an appropriate speed
    MAKE_PID := $(shell echo $$PPID)
    JOB_FLAG := $(filter -j%, $(subst -j ,-j,$(shell ps T | grep "^\s*$(MAKE_PID).*$(MAKE)")))
    JOBS     := $(subst -j,,$(JOB_FLAG))
    tmp := $(shell $(MAKE) -j$(JOBS) -f make.gen.hipMAGMA 1>&2)
else
    $(warning BACKEND: $(BACKEND) not recognized)
endif

# and utilities
ARCH        ?= ar
ARCHFLAGS   ?= cr
RANLIB      ?= ranlib


# --------------------
# flags/settings

# Use -fPIC to make shared (.so) and static (.a) library;
# can be commented out if making only static library.
FPIC        ?= -fPIC

# now, generate our flags
CFLAGS      ?= -O3 $(FPIC) -DNDEBUG -DADD_ -Wall -fopenmp -std=c99
CXXFLAGS    ?= -O3 $(FPIC) -DNDEBUG -DADD_ -Wall -fopenmp -std=c++11
FFLAGS      ?= -O3 $(FPIC) -DNDEBUG -DADD_ -Wall -Wno-unused-dummy-argument
F90FLAGS    ?= -O3 $(FPIC) -DNDEBUG -DADD_ -Wall -Wno-unused-dummy-argument -x f95-cpp-input
LDFLAGS     ?=     $(FPIC)                       -fopenmp

ifndef $(and DEVCCFLAGS, NVCCFLAGS)
    DEVCCFLAGS  ?= -O3         -DNDEBUG -DADD_
endif
# DEVCCFLAGS are populated later in `backend-specific`

# Extension for object files: o for unix, obj for Windows?
o_ext      ?= o

# where to install to?
prefix     ?= /usr/local/magma

# ------------------------------------------------------------------------------
# MAGMA-specific programs & flags

ifeq ($(blas_fix),1)
    # prepend -lblas_fix to LIB (it must come before LAPACK library/framework)
    LIB := -lblas_fix $(LIB)
endif

LIBS       = $(LIBDIR) $(LIB)

# preprocessor flags. See below for MAGMA_INC
CPPFLAGS   = $(INC) $(MAGMA_INC)

# where testers look for MAGMA libraries
RPATH      = -Wl,-rpath,${abspath ./lib}

codegen    = ./tools/codegen.py


ifeq ($(BACKEND),cuda)

	# Add legacy flags
	DEVCCFLAGS += $(NVCCFLAGS)

	# ------------------------------------------------------------------------------
	# NVCC options for the different cards
	# First, add smXX for architecture names
	# Internal CUDA architectures we support
	# TODO: Filter on regex to discard the named architectures?
	CUDA_ARCH_ := $(GPU_TARGET)
	ifneq ($(findstring Kepler, $(GPU_TARGET)),)
		CUDA_ARCH_ += sm_30
		CUDA_ARCH_ += sm_35
	endif
	ifneq ($(findstring Maxwell, $(GPU_TARGET)),)
		CUDA_ARCH_ += sm_50
	endif
	ifneq ($(findstring Pascal, $(GPU_TARGET)),)
		CUDA_ARCH_ += sm_60
	endif
	ifneq ($(findstring Volta, $(GPU_TARGET)),)
		CUDA_ARCH_ += sm_70
	endif
	ifneq ($(findstring Turing, $(GPU_TARGET)),)
		CUDA_ARCH_ += sm_75
	endif
	ifneq ($(findstring Ampere, $(GPU_TARGET)),)
		CUDA_ARCH_ += sm_80
	endif


	# Remember to add to CMakeLists.txt too!

	# Next, add compile options for specific smXX
	# sm_xx is binary, compute_xx is PTX for forward compatability
	# MIN_ARCH is lowest requested version
	#          Use it ONLY in magma_print_environment; elsewhere use __CUDA_ARCH__ or magma_getdevice_arch()
	# NV_SM    accumulates sm_xx for all requested versions
	# NV_COMP  is compute_xx for highest requested version
	#
	# See also $(info compile for ...) in Makefile


    CUDA_ARCH_UNKNOWN_ = $(filter-out sm_% Kepler Maxwell Pascal Volta Turing Ampere, $(CUDA_ARCH_))
    ifneq ($(CUDA_ARCH_UNKNOWN_),)
        $(error ERROR: unknown `$(CUDA_ARCH_UNKNOWN_)` in GPU_TARGET)
    endif

	# Now, sort sm's
    SMS      := $(patsubst sm_%,%,$(filter sm_%, $(CUDA_ARCH_)))
    SMS      := $(shell printf "%s\n" $(SMS) | sort -n)


    # code=sm_XX is binary, code=compute_XX is PTX
    GENCODE_SM      = -gencode arch=compute_$(sm),code=sm_$(sm)
    GENCODE_COMP    = -gencode arch=compute_$(sm),code=compute_$(sm)

    # Get gencode options for all sm_XX in cuda_arch_.
    NV_SM    := $(foreach sm,$(SMS),$(GENCODE_SM))
    NV_COMP  := $(foreach sm,$(SMS),$(GENCODE_COMP))

	# Check for empty
    ifeq ($(NV_SM),)
        $(error ERROR: unknown `GPU_TARGET=$(GPU_TARGET)`. Set cuda_arch to one or more of Kepler, Maxwell, Pascal, Volta, Turing, Ampere, or valid sm_XX from nvcc -h)
    else
        # Get last option (last 2 words) of nv_compute.
        nwords := $(words $(NV_COMP))
        nwords_1 := $(shell expr $(nwords) - 1)
        NV_COMP_LAST := $(wordlist $(nwords_1), $(nwords), $(NV_COMP))
    endif

    # Use all sm_XX (binary), and the last compute_XX (PTX) for forward compatibility.
    DEVCCFLAGS += $(NV_SM) $(NV_COMP_LAST)
    LIBS += -lcublas -lcudart

    # Get first (minimum) architecture
	# (add zero, so its comparable to '__CUDA_ARCH__')
    CUDA_ARCH_MIN := $(word 1, $(SMS))0
    ifeq ($(CUDA_ARCH_MIN),)
        $(error GPU_TARGET, currently $(GPU_TARGET), must contain one or more of Fermi, Kepler, Maxwell, Pascal, Volta, Turing, or valid sm_[0-9][0-9]. Please edit your make.inc file)
    endif
else ifeq ($(BACKEND),hip)

	# ------------------------------------------------------------------------------
	# hipcc backend
	# Source: https://llvm.org/docs/AMDGPUUsage.html#target-triples

	# Filter our human readable names and replace with numeric names
    HIP_ARCH_ := $(GPU_TARGET)
	ifneq ($(findstring kaveri, $(GPU_TARGET)),)
		HIP_ARCH_ += gfx700
	endif
	ifneq ($(findstring hawaii, $(GPU_TARGET)),)
		HIP_ARCH_ += gfx701
	endif
	ifneq ($(findstring kabini, $(GPU_TARGET)),)
		HIP_ARCH_ += gfx703
	endif
	ifneq ($(findstring mullins, $(GPU_TARGET)),)
		HIP_ARCH_ += gfx703
	endif
	ifneq ($(findstring bonaire, $(GPU_TARGET)),)
		HIP_ARCH_ += gfx704
	endif
	ifneq ($(findstring carrizo, $(GPU_TARGET)),)
		HIP_ARCH_ += gfx801
	endif
	ifneq ($(findstring iceland, $(GPU_TARGET)),)
		HIP_ARCH_ += gfx802
	endif
	ifneq ($(findstring tonga, $(GPU_TARGET)),)
		HIP_ARCH_ += gfx802
	endif
	ifneq ($(findstring fiji, $(GPU_TARGET)),)
		HIP_ARCH_ += gfx803
	endif
	# These are in the documentation, and the leftmost column *seems* like a continuation
	#   of gfx803
	ifneq ($(findstring polaris10, $(GPU_TARGET)),)
		HIP_ARCH_ += gfx803
	endif
	ifneq ($(findstring polaris11, $(GPU_TARGET)),)
		HIP_ARCH_ += gfx803
	endif

	ifneq ($(findstring tongapro, $(GPU_TARGET)),)
		HIP_ARCH_ += gfx805
	endif
	ifneq ($(findstring stoney, $(GPU_TARGET)),)
		HIP_ARCH_ += gfx810
	endif

    ## Suggestion by Mark (from SLATE)
    # Valid architecture numbers
    # TODO: remove veryold ones?
    VALID_GFXS = 600 601 602 700 701 702 703 704 705 801 802 803 805 810 900 902 904 906 908 909 90a 90c 1010 1011 1012 1030 1031 1032 1033


	# Generated GFX option
    TARGET_GFX      = --amdgpu-target=gfx$(gfx)

    # Get gencode options for all sm_XX in cuda_arch_.
    AMD_GFX    := $(filter %, $(foreach gfx, $(VALID_GFXS),$(if $(findstring gfx$(gfx), $(HIP_ARCH_)),$(TARGET_GFX))))

    ifeq ($(AMD_GFX),)
        $(error GPU_TARGET, currently $(GPU_TARGET), must contain one or more of the targets for AMDGPUs (https://llvm.org/docs/AMDGPUUsage.html#target-triples), or valid gfx[0-9][0-9][0-9][0-9]?. Please edit your make.inc file)
    else
    endif

    # Use all sm_XX (binary), and the last compute_XX (PTX) for forward compatibility.
    DEVCCFLAGS += $(AMD_GFX)

    # Get first (minimum) architecture
	# NOTE: Not so useful for HIP
    #MIN_ARCH := $(wordlist 1, 1, $(foreach gfx, $(VALID_GFXS),$(if $(findstring gfx$(gfx), $(HIP_ARCH_)),$(gfx))))
	#ifeq ($(MIN_ARCH),)
	#	$(error GPU_TARGET, currently $(GPU_TARGET), did not contain a minimum arch)
	#endif

endif


# ------------------------------------------------------------------------------
# Define the pointer size for fortran compilation
# If there's an issue compiling sizeptr, assume 8 byte (64 bit) pointers
PTRFILE = control/sizeptr.c
PTROBJ  = control/sizeptr.$(o_ext)
PTREXEC = control/sizeptr
PTRSIZE = $(shell if [ -x $(PTREXEC) ]; then $(PTREXEC); else echo 8; fi)
PTROPT  = -Dmagma_devptr_t="integer(kind=$(PTRSIZE))"

$(PTREXEC): $(PTROBJ)
	-$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $<
	touch $@

$(PTROBJ): $(PTRFILE)
	-$(CC) $(CFLAGS) -c -o $@ $<
	touch $@


# ------------------------------------------------------------------------------
# include sub-directories

# variables that multiple sub-directories add to.
# these MUST be := defined, not = defined, for $(cdir) to work.
hdr                  :=
libmagma_src         :=
libmagma_dynamic_src :=
testing_src          :=
libsparse_src        :=
libsparse_dynamic_src:=
sparse_testing_src   :=

subdirs := \
	blas_fix            \
	control             \
	include             \
	src                 \
	testing/lin         \

# the directory in which the MAGMA sparse source is located
# change to sparse_hip for hipified sources
# right now, just use old one so the dense section still builds

ifeq ($(BACKEND),cuda)
	SPARSE_DIR ?= sparse
	subdirs += interface_cuda
	subdirs += testing
	subdirs += magmablas

    # add all sparse folders
	# Don't do it for HIP yet
    subdirs += $(SPARSE_DIR) $(SPARSE_DIR)/blas $(SPARSE_DIR)/control $(SPARSE_DIR)/include $(SPARSE_DIR)/src $(SPARSE_DIR)/testing

else ifeq ($(BACKEND),hip)
	SPARSE_DIR ?= ./sparse_hip
	subdirs += interface_hip
	subdirs += magmablas_hip
	subdirs += testing

    subdirs += $(SPARSE_DIR) $(SPARSE_DIR)/blas $(SPARSE_DIR)/control $(SPARSE_DIR)/include $(SPARSE_DIR)/src $(SPARSE_DIR)/testing

endif




Makefiles := $(addsuffix /Makefile.src, $(subdirs))

#$(info $$Makefiles=$(Makefiles))

include $(Makefiles)

-include Makefile.internal
-include Makefile.local
-include Makefile.gen.$(BACKEND)

#$(info $$libmagma_src=$(libmagma_src))
#$(info $$libmagma_all=$(libmagma_all))

# ------------------------------------------------------------------------------
# objects

ifeq ($(FORT),)
    liblapacktest_all2 := $(filter     %_no_fortran.cpp, $(liblapacktest_all))
else
    liblapacktest_all2 := $(filter-out %_no_fortran.cpp, $(liblapacktest_all))
endif

ifeq ($(FORT),)
    libmagma_all := $(filter-out %.f %.f90 %.F90, $(libmagma_all))
    testing_all  := $(filter-out %.f %.f90 %.F90, $(testing_all))
endif

libmagma_obj       := $(addsuffix .$(o_ext), $(basename $(libmagma_all)))
libblas_fix_obj    := $(addsuffix .$(o_ext), $(basename $(libblas_fix_src)))
libtest_obj        := $(addsuffix .$(o_ext), $(basename $(libtest_all)))
liblapacktest_obj  := $(addsuffix .$(o_ext), $(basename $(liblapacktest_all2)))
testing_obj        := $(addsuffix .$(o_ext), $(basename $(testing_all)))
libsparse_obj      := $(addsuffix .$(o_ext), $(basename $(libsparse_all)))
