=== debian/changelog ===
magma (2.6.2-1build1) mantic; urgency=medium

  * No-change rebuild against libcublas12

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 05 Jul 2023 21:17:36 +0000

magma (2.6.2-1) unstable; urgency=medium

  * New upstream version 2.6.2
  * Refresh and rebase existing patches.

 -- Mo Zhou <lumin@debian.org>  Thu, 24 Mar 2022 11:45:02 -0400
