=== debian/changelog ===
magma (2.7.2+ds-1) unstable; urgency=medium

  * New upstream version 2.7.2+ds (Closes: #1036679)
  * watch: Update upstream download page link.
  * Rebase existing patches.
  * Fix the superfluous file patterns in d/copyright.

 -- Mo Zhou <lumin@debian.org>  Wed, 06 Sep 2023 21:01:52 -0400

magma (2.7.0+ds-1) unstable; urgency=medium

  * New upstream version 2.7.0+ds
  * Refresh existing patches. Deprecate gpu-target.patch

 -- Mo Zhou <lumin@debian.org>  Thu, 15 Dec 2022 18:22:36 -0500
